package com.arms.api.engine.services;

import com.arms.api.analysis.resource.dto.ResourceAggrDTO;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.egovframework.javaservice.esframework.esquery.EsQuery;
import com.arms.egovframework.javaservice.esframework.esquery.EsQueryBuilder;
import com.arms.egovframework.javaservice.esframework.esquery.filter.TermsQueryFilter;
import com.arms.egovframework.javaservice.esframework.repository.EsCommonRepositoryWrapper;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;

@SpringBootTest
@ActiveProfiles("dev")
public class IssueIndexServiceProcessTest extends EsCommonRepositoryWrapper<AlmIssueEntity> {

	@Test
	public void test(){

		ResourceAggrDTO resourceAggrDTO = new ResourceAggrDTO();
		resourceAggrDTO.setEsQuery(getQuery());

		AlmIssueEntity almIssueEntity = this.findRecentHits(resourceAggrDTO).toDocs().stream().findFirst().orElseGet(
			AlmIssueEntity::new);
		System.out.println(almIssueEntity);
	}

	private EsQuery getQuery() {
		EsQuery esQuery = new EsQueryBuilder()
				.bool(
						new TermsQueryFilter("id","1797187033776577721_DEMO_DEMO-21")
				);
		return esQuery;
	}
}
