package com.arms.api.search_engine.service;

import com.arms.api.analysis.resource.dto.ResourceAggrDTO;
import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.egovframework.javaservice.esframework.esquery.EsQuery;
import com.arms.egovframework.javaservice.esframework.esquery.EsQueryBuilder;
import com.arms.egovframework.javaservice.esframework.esquery.filter.QueryStringFilter;
import com.arms.egovframework.javaservice.esframework.esquery.filter.RangeQueryFilter;
import com.arms.egovframework.javaservice.esframework.model.vo.v2.DocumentAggregations;
import com.arms.egovframework.javaservice.esframework.repository.EsCommonRepositoryWrapper;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;

@ActiveProfiles("dev")
@SpringBootTest
class AlmIssueSearchImplTest extends EsCommonRepositoryWrapper<AlmIssueEntity> {

    @Test
    public void test(){

        ResourceAggrDTO resourceAggrDTO = new ResourceAggrDTO();
        // resourceAggrDTO.set페이지(5);
        // resourceAggrDTO.set크기(0);
        resourceAggrDTO.set메인_그룹_필드("project.project_name.keyword");
        resourceAggrDTO.setEsQuery(getSearchTermQuery());

        DocumentAggregations documentAggregations = this.aggregateRecentDocs(resourceAggrDTO);
        System.out.println(documentAggregations);
    }

    private EsQuery getSearchTermQuery() {
        EsQuery esQuery = new EsQueryBuilder()
                .bool(
                        new QueryStringFilter("searchTerm"),
                        RangeQueryFilter.of("@timestamp").betweenDate(null, null)
                );
        return esQuery;
    }
}